# ConcurrentSim (formerly SimJulia)

<table>
    <tr>
        <td>Documentation</td>
        <td>
            <a href="https://juliadynamics.github.io/ConcurrentSim.jl/stable"><img src="https://img.shields.io/badge/docs-stable-blue.svg" alt="Documentation of latest stable version"></a>
            <a href="https://juliadynamics.github.io/ConcurrentSim.jl/dev"><img src="https://img.shields.io/badge/docs-dev-blue.svg" alt="Documentation of dev version"></a>
        </td>
    </tr><tr></tr>
    <tr>
        <td>Continuous integration</td>
        <td>
            <a href="https://github.com/JuliaDynamics/ConcurrentSim.jl/actions?query=workflow%3ACI+branch%3Amaster"><img src="https://img.shields.io/github/actions/workflow/status/JuliaDynamics/ConcurrentSim.jl/ci.yml?branch=master" alt="GitHub Workflow Status"></a>
        </td>
    </tr><tr></tr>
    <tr>
        <td>Code coverage</td>
        <td>
            <a href="https://codecov.io/gh/JuliaDynamics/ConcurrentSim.jl"><img src="https://img.shields.io/codecov/c/gh/JuliaDynamics/ConcurrentSim.jl?label=codecov" alt="Test coverage from codecov"></a>
        </td>
    </tr><tr></tr>
    <tr>
        <td>Static analysis with</td>
        <td>
            <a href="https://github.com/aviatesk/JET.jl"><img src="https://img.shields.io/badge/%F0%9F%9B%A9%EF%B8%8F_tested_with-JET.jl-233f9a" alt="JET static analysis"></a>
            <a href="https://github.com/JuliaTesting/Aqua.jl"><img src="https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg" alt="Aqua QA"></a>
        </td>
    </tr>
</table>

A discrete event process oriented simulation framework written in [Julia](http://julialang.org/) inspired by the Python library [SimPy](https://simpy.readthedocs.io/). One of the longest-lived Julia packages (originally under the name SimJulia).

## Installation

ConcurrentSim.jl is a [registered package](http://pkg.julialang.org), and is installed by running

```julia
julia> Pkg.add("ConcurrentSim")
```

## License

[![License](http://img.shields.io/badge/license-MIT-brightgreen.svg?style=flat)](LICENSE.md)

## Authors

* Ben Lauwens, Royal Military Academy, Brussels, Belgium.
* Maintainer volunteers from the JuliaDynamics and QuantumSavory organizations.

## Contributing

* To discuss problems or feature requests, file an issue. For bugs, please include as much information as possible, including operating system, julia version, and version of the dependencies: `DataStructures` and `ResumableFunctions`.
* To contribute, make a pull request. Contributions should include tests for any new features/bug fixes.

## Release Notes

A [detailed change log is kept](https://github.com/JuliaDynamics/ConcurrentSim.jl/blob/master/CHANGELOG.md).

## Alternatives

`ConcurrentSim.jl` and `DiscreteEvents.jl` both provide for typical event-based simulations.
`ConcurrentSim.jl` is built around coroutines (implemented in `ResumableFunctions.jl`), while `DiscreteEvents.jl` uses Julia's async primitives via `Channels`.
`DiscreteEvents.jl` has an explicit clock that "ticks" at a fixed finite resolution, while `ConcurrentSim.jl` uses coroutines to make arbitrary jumps in time.
If you are evaluating which library to you for your goals, `ConcurrentSim.jl` might be a good choice if you are used to python's SimPy, but otherwise you are advised to try a small demo project in each and do your own benchmarks. Do not hesitate to submit issues on Github with questions or suggestions or feature requests. We value hearing what your experience with this library (compared to other libraries) has been.

struct Initialize <: AbstractEvent
  bev :: BaseEvent
  function Initialize(env::Environment)
    new(BaseEvent(env))
  end
end

mutable struct Process <: DiscreteProcess
  bev :: BaseEvent
  fsmi :: ResumableFunctions.FiniteStateMachineIterator
  target :: AbstractEvent
  resume :: Function
  function Process(func::Function, env::Environment, args...; kwargs...)
    proc = new()
    proc.bev = BaseEvent(env)
    proc.fsmi = func(env, args...; kwargs...)
    proc.target = schedule(Initialize(env))
    proc.resume = @callback execute(proc.target, proc)
    proc
  end
end

macro process(expr)
  expr.head !== :call && error("Expression is not a function call!")
  esc(:(Process($(expr.args...))))
end

function execute(ev::AbstractEvent, proc::Process)
  try
    env = environment(ev)
    set_active_process(env, proc)
    target = proc.fsmi(value(ev))
    reset_active_process(env)
    if proc.fsmi._state === 0xff
      schedule(proc; value=target)
    else
      proc.target = state(target) == processed ? timeout(env; value=value(target)) : target
      proc.resume = @callback execute(proc.target, proc)
    end
  catch exc
    rethrow(exc)
  end
end

struct Interrupt <: AbstractEvent
  bev :: BaseEvent
  function Interrupt(env::Environment)
    new(BaseEvent(env))
  end
end

function execute_interrupt(ev::Interrupt, proc::Process)
  remove_callback(proc.resume, proc.target)
  execute(ev, proc)
end

function interrupt(proc::Process, cause::Any=nothing)
  env = environment(proc)
  if proc.fsmi._state !== 0xff
    proc.target isa Initialize && schedule(proc.target; priority=typemax(Int))
    target = schedule(Interrupt(env); priority=typemax(Int), value=InterruptException(active_process(env), cause))
    @callback execute_interrupt(target, proc)
  end
  timeout(env; priority=typemax(Int))
end

using ConcurrentSim, Distributions, BenchmarkTools

function exp_source(sim::Simulation, lambd::Float64, server::Resource, mu::Float64)
  while true
    dt = rand(Exponential(1/lambd))
    yield(timeout(sim, dt))
    @oldprocess customer(sim, server, mu)
  end
end

function customer(sim::Simulation, server::Resource, mu::Float64)
  yield(request(server))
  dt = rand(Exponential(1/mu))
  yield(timeout(sim, dt))
  yield(unlock(server))
end

function customer2(sim::Simulation, server::Resource, mu::Float64)
  request(server) do req
    yield(req)
    dt = rand(Exponential(1/mu))
    yield(timeout(sim, dt))
  end
end

function test_mm1(n::Float64)
  sim = Simulation()
  server = Resource(sim)
  @oldprocess exp_source(sim, 1.0, server, 1.1)
  run(sim, n)
end

test_mm1(100.0)
@btime test_mm1(100.0)

using ConcurrentSim

## Containers with Float64 priority
sim = Simulation()
con = Container{Float64}(sim,0)
put!(con, 1; priority = 10)
put!(con, 1; priority = 9.1)
put!(con, 1; priority = UInt(9))
put!(con, 1; priority = BigInt(8))
put!(con, 1; priority = BigFloat(7.1))
put!(con, 1; priority = 7)
put!(con, 1; priority = 6.1)
put!(con, 1; priority = BigInt(5))
put!(con, 1; priority = BigFloat(-Inf))
@show keys(con.put_queue)

## Containers with Int64 priority
sim = Simulation()
con = Container{Int}(sim,0)
put!(con, 1; priority = 10)
put!(con, 1; priority = 9.0)
put!(con, 1; priority = UInt(9))
put!(con, 1; priority = BigInt(8))
put!(con, 1; priority = BigFloat(7.0))
put!(con, 1; priority = 7)
put!(con, 1; priority = 6.0)
put!(con, 1; priority = BigInt(5))
put!(con, 1; priority = typemin(Int))
@show keys(con.put_queue)

## Stores with Float64 priority
sim = Simulation()
sto = Store{Symbol,Float64}(sim; capacity = UInt(5))
put!(sto, :a; priority = 10)
put!(sto, :a; priority = 9.1)
put!(sto, :a; priority = UInt(9))
put!(sto, :a; priority = BigInt(8))
put!(sto, :a; priority = BigFloat(7.1))
put!(sto, :b; priority = 7)
put!(sto, :b; priority = 6.1)
put!(sto, :b; priority = BigInt(5))
put!(sto, :b; priority = BigFloat(-Inf))
@show sto.items
@show keys(sto.put_queue)

## Stores with Int64 priority
sim = Simulation()
sto = Store{Symbol,Int}(sim; capacity = UInt(5))
put!(sto, :a; priority = 10)
put!(sto, :a; priority = 9.0)
put!(sto, :a; priority = UInt(9))
put!(sto, :a; priority = BigInt(8))
put!(sto, :a; priority = BigFloat(7.0))
put!(sto, :b; priority = 7)
put!(sto, :b; priority = 6.0)
put!(sto, :b; priority = BigInt(5))
put!(sto, :b; priority = typemin(UInt))
@show sto.items
@show keys(sto.put_queue)

@testset "Resource priority evaluation" begin
  using ResumableFunctions

  let sim = Simulation()
    @resumable function f(env, res)
      @yield lock(res)
    end

    res = Resource(sim)
    ev1 = unlock(res, priority=5)
    ev2 = unlock(res)
    @process f(sim, res)
    run(sim)
    @test_broken state(ev1) === ConcurrentSim.processed
  end
end

struct ContainerKey{N<:Real, T<:Number} <: ResourceKey
  id :: UInt
  amount :: N
  priority :: T
end

"""
    Container{N<:Real, T<:Number}(env::Environment, capacity::N=one(N); level::N=zero(N))

A "Container" resource object, storing up to `capacity` units of a resource (of type `N`).

There is a `Resource` alias for `Container{Int, Int}`.

`Resource()` with default capacity of `1` is very similar to a typical lock.
The [`lock`](@ref) and [`unlock`](@ref) functions are a convenient way to interact with such a "lock",
in a way mostly compatible with other discrete event and concurrency frameworks.
The `request` and `release` aliases are also available for these two functions.

See [`Store`](@ref) for a more channel-like resource.

Think of `Resource` and `Container` as locks and of `Store` as channels. They block only if empty (on taking) or full (on storing).
"""
mutable struct Container{N<:Real, T<:Number} <: AbstractResource
  env :: Environment
  capacity :: N
  level :: N
  seid :: UInt
  put_queue :: DataStructures.PriorityQueue{Put, ContainerKey{N, T}}
  get_queue :: DataStructures.PriorityQueue{Get, ContainerKey{N, T}}
  function Container{N, T}(env::Environment, capacity::N=one(N); level=zero(N)) where {N<:Real, T<:Number}
    new(env, capacity, N(level), zero(UInt), DataStructures.PriorityQueue{Put, ContainerKey{N, T}}(), DataStructures.PriorityQueue{Get, ContainerKey{N, T}}())
  end
end

function Container(env::Environment, capacity::N; level=zero(N)) where {N<:Real}
  Container{N, Int}(env, capacity; level=N(level))
end

function Container{T}(env::Environment, capacity::N; level=zero(N)) where {N<:Real, T<:Number}
  Container{N, T}(env, capacity; level=N(level))
end

"""An alias for `Container{Int, Int}`, one of the most frequently used types of synchronization primitive."""
const Resource = Container{Int, Int}

function put!(con::Container{N, T}, amount::N; priority=zero(T)) where {N<:Real, T<:Number}
  put_ev = Put(con.env)
  con.put_queue[put_ev] = ContainerKey{N,T}(con.seid+=one(UInt), amount, T(priority))
  @callback trigger_get(put_ev, con)
  trigger_put(put_ev, con)
  put_ev
end

"""
    lock(res::Resource)

Locks the Resource and return the lock event.
If the capacity of the Container is greater than 1,
multiple requests can be made before blocking occurs.
"""
lock(res::Container; priority=0) = put!(res, 1; priority)

"""
    trylock(res::Resource)

If the Resource is not locked, locks it and return the lock event.
Returns `false` if the Container is locked, similarly to the meaning of `trylock` for `Base.ReentrantLock`.

If the capacity of the Container is greater than 1,
multiple requests can be made before blocking occurs.

```jldoctest
julia> sim = Simulation(); res = Resource(sim);

julia> ev = tryrequest(res)
ConcurrentSim.Put 1

julia> typeof(ev)
ConcurrentSim.Put

julia> tryrequest(res)
false
```
"""
function trylock(res::Resource; priority=0)
    islocked(res) && return false # TODO check priority
    lock(res; priority)
end

function get(con::Container{N, T}, amount::N; priority=zero(T)) where {N<:Real, T<:Number}
  get_ev = Get(con.env)
  con.get_queue[get_ev] = ContainerKey(con.seid+=one(UInt), amount, T(priority))
  @callback trigger_put(get_ev, con)
  trigger_get(get_ev, con)
  get_ev
end

"""
    unlock(res::Resource)

Unlocks the Resource and return the unlock event.
"""
unlock(res::Resource; priority::Number=0) = get(res, 1; priority=priority)

function do_put(con::Container{N, T}, put_ev::Put, key::ContainerKey{N, T}) where {N<:Real, T<:Number}
  con.level + key.amount > con.capacity && return false
  schedule(put_ev)
  con.level += key.amount
  true
end

function do_get(con::Container{N, T}, get_ev::Get, key::ContainerKey{N, T}) where {N<:Real, T<:Number}
  con.level - key.amount < zero(N) && return false
  schedule(get_ev)
  con.level -= key.amount
  true
end

"""
    isready(::Container)

Returns `true` if the Container is not empty, similarly to the meaning of `isready` for `Base.Channel`.

```jldoctest
julia> sim = Simulation(); res = Resource(sim); isready(res)
false

julia> request(res); isready(res)
true
```
"""
isready(c::Container) = c.level > 0

"""
    islocked(::Container)

Returns `true` if the store is full, similarly to the meaning of `islocked` for `Base.ReentrantLock`.

```jldoctest
julia> sim = Simulation(); res = Resource(sim, 2); islocked(res)
false

julia> request(res); islocked(res)
false

julia> request(res); islocked(res)
true
```
"""
islocked(c::Container) = c.level==c.capacity

take!(::Container, args...) = error("There is no well defined `take!` for `Container`. Instead of attempting `take!` consider using `unlock(::Container)` or use a `Store` instead of a `Resource` or `Container`. Think of `Resource` and `Container` as locks and of `Store` as channels. They block only if empty (on taking) or full (on storing).")

@doc raw"""
    DelayQueue{T}

A queue in which items are stored in a FIFO order, but are only available after a delay.

```jldoctest
julia> sim = Simulation()
       queue = DelayQueue{Symbol}(sim, 10)
       @resumable function producer(env, queue)
           for item in [:a,:b,:a,:c]
               @info "putting $item at time $(now(env))"
               put!(queue, item)
               @yield timeout(env, 2)
           end
       end
       @resumable function consumer(env, queue)
           @yield timeout(env, 5)
           while true
               t = @yield take!(queue)
               @info "taking $(t) at time $(now(env))"
           end
       end
       @process producer(sim, queue)
       @process consumer(sim, queue)
       run(sim, 30)
[ Info: putting a at time 0.0
[ Info: putting b at time 2.0
[ Info: putting a at time 4.0
[ Info: putting c at time 6.0
[ Info: taking a at time 10.0
[ Info: taking b at time 12.0
[ Info: taking a at time 14.0
[ Info: taking c at time 16.0
```
"""
mutable struct DelayQueue{T}
    store::QueueStore{T, Int}
    delay::Float64
end
function DelayQueue(env::Environment, delay)
    return DelayQueue(QueueStore{Any}(env), float(delay))
end
function DelayQueue{T}(env::Environment, delay) where T
    return DelayQueue(QueueStore{T}(env), float(delay))
end

@resumable function latency(env::Environment, channel::DelayQueue, value)
    @yield timeout(channel.store.env, channel.delay)
    put!(channel.store, value)
end

function Base.put!(channel::DelayQueue, value)
    @process latency(channel.store.env, channel, value) # start the process, but do not wait on it
end

function Base.take!(channel::DelayQueue)
    get(channel.store)
end

abstract type ResourceKey end

abstract type AbstractResource end

function show(io::IO, res::AbstractResource)
  print(io, "$(typeof(res))")
end

abstract type ResourceEvent <: AbstractEvent end

struct Put <: ResourceEvent
  bev :: BaseEvent
  function Put(env::Environment)
    new(BaseEvent(env))
  end
end

struct Get <: ResourceEvent
  bev :: BaseEvent
  function Get(env::Environment)
    new(BaseEvent(env))
  end
end

function isless(a::ResourceKey, b::ResourceKey)
  (a.priority < b.priority) || (a.priority === b.priority && a.id < b.id)
end

function trigger_put(put_ev::ResourceEvent, res::AbstractResource)
  queue = DataStructures.PriorityQueue(res.put_queue)
  while length(queue) > 0
    (put_ev, key) = DataStructures.first(queue)
    proceed = do_put(res, put_ev, key)
    state(put_ev) === scheduled && DataStructures.popat!(res.put_queue, put_ev)
    proceed ? DataStructures.popfirst!(queue) : break
  end
end

function trigger_get(get_ev::ResourceEvent, res::AbstractResource)
  queue = DataStructures.PriorityQueue(res.get_queue)
  while length(queue) > 0
    (get_ev, key) = DataStructures.first(queue)
    proceed = do_get(res, get_ev, key)
    state(get_ev) === scheduled && DataStructures.popat!(res.get_queue, get_ev)
    proceed ? DataStructures.popfirst!(queue) : break
  end
end

function cancel(res::AbstractResource, put_ev::Put)
  DataStructures.popat!(res.put_queue, put_ev)
end

function cancel(res::AbstractResource, get_ev::Get)
  DataStructures.popat!(res.get_queue, get_ev)
end

"""
Main module for ConcurrentSim.jl – a discrete event process oriented simulation framework for Julia.
"""
module ConcurrentSim

  using DataStructures
  using Dates
  using ResumableFunctions

  import Base: run, isless, show, yield, get, put!, take!, isready, islocked, unlock, lock, trylock, &, |
  import Dates: now

  export AbstractEvent, Environment, value, state, environment
  export Event, succeed, fail, @callback, remove_callback
  export timeout
  export Operator, &, |, AllOf, AnyOf
  export @resumable, @yield
  export AbstractProcess, Simulation, run, now, active_process, StopSimulation
  export Process, @process, interrupt
  export Container, Resource, Store, StackStore, QueueStore, DelayQueue
  export put!, get, cancel, request, tryrequest, release
  export nowDatetime

  include("base.jl")
  include("events.jl")
  include("operators.jl")
  include("simulations.jl")
  include("processes.jl")
  include("resources/base.jl")
  include("resources/containers.jl")
  include("resources/stores.jl")
  include("resources/ordered_stores.jl")
  include("resources/delayed_stores.jl")
  include("utils/time.jl")
  include("deprecated_aliased.jl")
end

using ResumableFunctions, ConcurrentSim, Distributions, BenchmarkTools

@resumable function exp_source(sim::Simulation, lambd::Float64, server::Resource, mu::Float64)
  while true
    dt = rand(Exponential(1 / lambd))
    @yield timeout(sim, dt)
    @process customer(sim, server, mu)
  end
end

@resumable function customer(sim::Simulation, server::Resource, mu::Float64)
  @yield request(server)
  dt = rand(Exponential(1 / mu))
  @yield timeout(sim, dt)
  @yield unlock(server)
end

function test_mm1(n::Float64)
  sim = Simulation()
  server = Resource(sim)
  @process exp_source(sim, 1.0, server, 1.1)
  run(sim, n)
end

test_mm1(100.0)
@btime test_mm1(100.0)

abstract type AbstractEvent end
abstract type Environment end

@enum EVENT_STATE idle=0 scheduled=1 processed=2

struct EventProcessed <: Exception
  ev :: AbstractEvent
end

struct EventNotIdle <: Exception
  ev :: AbstractEvent
end

mutable struct BaseEvent
  env :: Environment
  id :: UInt
  callbacks :: Vector{Function}
  state :: EVENT_STATE
  value :: Any
  function BaseEvent(env::Environment)
    new(env, env.eid+=one(UInt), Vector{Function}(), idle, nothing)
  end
end

function show(io::IO, ev::AbstractEvent)
  print(io, "$(typeof(ev)) $(ev.bev.id)")
end

function show(io::IO, env::Environment)
  if env.active_proc === nothing
    print(io, "$(typeof(env)) time: $(now(env)) active_process: nothing")
  else
    print(io, "$(typeof(env)) time: $(now(env)) active_process: $(env.active_proc)")
  end
end

function environment(ev::AbstractEvent) :: Environment
  ev.bev.env
end

function value(ev::AbstractEvent) :: Any
  ev.bev.value
end

function state(ev::AbstractEvent) :: EVENT_STATE
  ev.bev.state
end

function append_callback(func::Function, ev::AbstractEvent, args::Any...) :: Function
  ev.bev.state === processed && throw(EventProcessed(ev))
  cb = ()->func(ev, args...)
  push!(ev.bev.callbacks, cb)
  cb
end

macro callback(expr::Expr)
  expr.head !== :call && error("Expression is not a function call!")
  esc(:(ConcurrentSim.append_callback($(expr.args...))))
end

function remove_callback(cb::Function, ev::AbstractEvent)
  i = findfirst(x -> x == cb, ev.bev.callbacks)
  i != 0 && deleteat!(ev.bev.callbacks, i)
end

function schedule(ev::AbstractEvent, delay::Number=0; priority=0, value=nothing)
  state(ev) === processed && throw(EventProcessed(ev))
  env = environment(ev)
  bev = ev.bev
  bev.value = value
  env.heap[bev] = EventKey(now(env) + delay, Int(priority), env.sid+=one(UInt))
  bev.state = scheduled
  ev
end

struct StopSimulation <: Exception
  value :: Any
  function StopSimulation(value::Any=nothing)
    new(value)
  end
end

function stop_simulation(ev::AbstractEvent)
  throw(StopSimulation(value(ev)))
end

function run(env::Environment, until::AbstractEvent)
  @callback stop_simulation(until)
  try
    while true
      step(env)
    end
  catch exc
    if isa(exc, StopSimulation)
      return exc.value
    else
      rethrow(exc)
    end
  end
end

using ConcurrentSim
using ResumableFunctions
using Test

@resumable function producer(env, queue)
    for item in [1,2,3,4]
        @info "putting $item at time $(now(env))"
        put!(queue, item)
        @yield timeout(env, 2)
    end
end
@resumable function consumer(env, queue)
    @yield timeout(env, 5)
    while true
        t = @yield take!(queue)
        @test isa(t, Float64)
        @info "taking $(t) at time $(now(env))"
    end
end

function runsim(storeconstructor)
    sim = Simulation()
    queue = storeconstructor(sim)
    @process producer(sim, queue)
    @process consumer(sim, queue)
    run(sim, 30)
end

runsim(sim->DelayQueue{Float64}(sim, 10))
runsim(sim->QueueStore{Float64}(sim))
runsim(sim->Store{Float64}(sim))

# formatting was different in older versions
VERSION >= v"1.8" && @test_throws "MethodError: Cannot `convert`" runsim(sim->Store{Symbol}(sim))

using ResumableFunctions, ConcurrentSim, BenchmarkTools

@resumable function fibonnaci(sim::Simulation)
  a = 0.0
  b = 1.0
  while true
    @yield timeout(sim, 1)
    a, b = b, a+b
  end
end

function run_test()
  sim = Simulation()
  @process fibonnaci(sim)
  run(sim, 10)
end

run_test()
@btime run_test()

"""
    StackStore{N, T<:Number}

A store in which items are stored in a FILO order.

```jldoctest
julia> sim = Simulation()
       store = Store{Symbol}(sim)
       stack = StackStore{Symbol}(sim)
       items = [:a,:b,:a,:c];

julia> [put!(store, item) for item in items];

julia> [value(take!(store)) for _ in 1:length(items)]
4-element Vector{Symbol}:
 :a
 :a
 :b
 :c

julia> [put!(stack, item) for item in items];

julia> [value(take!(stack)) for _ in 1:length(items)]
4-element Vector{Symbol}:
 :c
 :a
 :b
 :a
```

See also: [`QueueStore`](@ref), [`Store`](@ref)
"""
const StackStore = Store{N, T, DataStructures.Stack{N}} where {N, T<:Number}
StackStore{N}(env::Environment; capacity=typemax(UInt)) where {N} = StackStore{N, Int}(env; capacity)

"""
    QueueStore{N, T<:Number}

A store in which items are stored in a FIFO order.

```jldoctest
julia> sim = Simulation()
       store = Store{Symbol}(sim)
       queue = QueueStore{Symbol}(sim)
       items = [:a,:b,:a,:c];

julia> [put!(store, item) for item in items];

julia> [value(take!(store)) for _ in 1:length(items)]
4-element Vector{Symbol}:
 :a
 :a
 :b
 :c

julia> [put!(queue, item) for item in items];

julia> [value(take!(queue)) for _ in 1:length(items)]
4-element Vector{Symbol}:
 :a
 :b
 :a
 :c
```

See also: [`StackStore`](@ref), [`Store`](@ref)
"""
const QueueStore = Store{N, T, DataStructures.Queue{N}} where {N, T<:Number}
QueueStore{N}(env::Environment; capacity=typemax(UInt)) where {N} = QueueStore{N, Int}(env; capacity)

function do_put(sto::StackStore{N, T}, put_ev::Put, key::StorePutKey{N, T}) where {N, T<:Number}
  if sto.load < sto.capacity
    sto.load += one(UInt)
    push!(sto.items, key.item)
    schedule(put_ev)
  end
  false
end

function do_get(sto::StackStore{N, T}, get_ev::Get, key::StoreGetKey{T}) where {N, T<:Number}
  key.filter !== get_any_item && error("Filtering not supported for `StackStore`. Use an unordered store instead, or submit a feature request for implementing filtering to our issue tracker.")
  isempty(sto.items) && return true
  item = pop!(sto.items)
  sto.load -= one(UInt)
  schedule(get_ev; value=item)
  true
end

function do_put(sto::QueueStore{N, T}, put_ev::Put, key::StorePutKey{N, T}) where {N, T<:Number}
  if sto.load < sto.capacity
    sto.load += one(UInt)
    push!(sto.items, key.item)
    schedule(put_ev)
  end
  false
end

function do_get(sto::QueueStore{N, T}, get_ev::Get, key::StoreGetKey{T}) where {N, T<:Number}
  key.filter !== get_any_item && error("Filtering not supported for `QueueStore`. Use an unordered store instead, or submit a feature request for implementing filtering to our issue tracker.")
  isempty(sto.items) && return true
  item = popfirst!(sto.items)
  sto.load -= one(UInt)
  schedule(get_ev; value=item)
  true
end

struct StorePutKey{N, T<:Number} <: ResourceKey
  id :: UInt
  item :: N
  priority :: T
end

struct StoreGetKey{T<:Number} <: ResourceKey
  id :: UInt
  filter :: Function
  priority :: T
end

"""
    Store{N, T<:Number}(env::Environment; capacity::UInt=typemax(UInt))

A store is a resource that can hold a number of items of type `N`. It is similar to a `Base.Channel` with a finite capacity ([`put!`](@ref) blocks after reaching capacity).
The [`put!`](@ref) and [`take!`](@ref) functions are a convenient way to interact with such a "channel" in a way mostly compatible with other discrete event and concurrency frameworks.

See [`Container`](@ref) for a more lock-like resource.

Think of `Resource` and `Container` as locks and of `Store` as channels/stacks. They block only if empty (on taking) or full (on storing).

`Store` does not guarantee any order of items. See [`StackStore`](@ref) and [`QueueStore`](@ref) for ordered variants.

```jldoctest
julia> sim = Simulation(); store = Store{Int}(sim);

julia> put!(store, 1); run(sim, 1); put!(store, 2);

julia> value(take!(store))
2

julia> value(take!(store))
1
```
"""
mutable struct Store{N, T<:Number, D} <: AbstractResource
  env :: Environment
  capacity :: UInt
  load :: UInt
  items :: D
  seid :: UInt
  put_queue :: DataStructures.PriorityQueue{Put, StorePutKey{N, T}}
  get_queue :: DataStructures.PriorityQueue{Get, StoreGetKey{T}}
  function Store{N, T, D}(env::Environment; capacity=typemax(UInt)) where {N, T<:Number, D}
    new(env, UInt(capacity), zero(UInt), D(), zero(UInt), DataStructures.PriorityQueue{Put, StorePutKey{N, T}}(), DataStructures.PriorityQueue{Get, StoreGetKey{T}}())
  end
end

function Store{N, T}(env::Environment; capacity=typemax(UInt)) where {N, T<:Number}
    Store{N, T, Dict{N, UInt}}(env; capacity=UInt(capacity))
end

function Store{N}(env::Environment; capacity=typemax(UInt)) where {N}
  Store{N, Int}(env; capacity=UInt(capacity))
end

"""
    put!(sto::Store, item::T)

Put an item into the store. Returns the put event, blocking if the store is full.
"""
function put!(sto::Store{N, T}, item::N; priority=zero(T)) where {N, T<:Number}
  put_ev = Put(sto.env)
  sto.put_queue[put_ev] = StorePutKey{N, T}(sto.seid+=one(UInt), item, T(priority))
  @callback trigger_get(put_ev, sto)
  trigger_put(put_ev, sto)
  put_ev
end

put!(sto::Store{N, T}, item; priority=zero(T)) where {N, T<:Number} = put!(sto, convert(N, item); priority)

get_any_item(::N) where N = true

function get(sto::Store{N, T, D}, filter::Function=get_any_item; priority=zero(T)) where {N, T<:Number, D}
  get_ev = Get(sto.env)
  sto.get_queue[get_ev] = StoreGetKey(sto.seid+=one(UInt), filter, T(priority))
  @callback trigger_put(get_ev, sto)
  trigger_get(get_ev, sto)
  get_ev
end

function do_put(sto::Store{N, T, Dict{N,UInt}}, put_ev::Put, key::StorePutKey{N, T}) where {N, T<:Number}
  if sto.load < sto.capacity
    sto.load += one(UInt)
    sto.items[key.item] = get(sto.items, key.item, zero(UInt)) + one(UInt)
    schedule(put_ev)
  end
  false
end

function do_get(sto::Store{N, T, Dict{N,UInt}}, get_ev::Get, key::StoreGetKey{T}) where {N, T<:Number}
  for (item, number) in sto.items
    if key.filter(item)
      sto.load -= one(UInt)
      if number === one(UInt)
        delete!(sto.items, item)
      else
        sto.items[item] = number - one(UInt)
      end
      schedule(get_ev; value=item)
      break
    end
  end
  true
end

"""
    isready(::Store)

Returns `true` if the store is not empty, similarly to the meaning of `isready` for `Base.Channel`.

```jldoctest
julia> sim = Simulation(); store = Store{Symbol}(sim); isready(store)
false

julia> put!(store, :message); isready(store)
true
```
"""
isready(sto::Store) = sto.load > 0

"""
    islocked(::Store)

Returns `true` if the store is full, similarly to the meaning of `islocked` for `Base.ReentrantLock`.

```jldoctest
julia> sim = Simulation(); store = Store{Symbol}(sim; capacity=2); islocked(store)
false

julia> put!(store, :message); islocked(store)
false

julia> put!(store, :another_message); islocked(store)
true
```
"""
islocked(sto::Store) = sto.load==sto.capacity

unlock(::Store) = error("There is no well defined way to \"unlock\" a Store without taking an element out of it. Instead of attempting `unlock` consider using `take!(::Store)` or use a `Resource` instead of a `Store`. Think of `Resource` and `Container` as locks and of `Store` as channels. They block only if empty (on taking) or full (on storing).")
lock(::Store) = error("There is no well defined way to \"lock\" or \"request\" a Store without storing an element in it. Instead of attempting `lock` consider using `put!(::Store, ...)` or use a `Resource` instead of a `Store`. Think of `Resource` and `Container` as locks and of `Store` as channels. They block only if empty (on taking) or full (on storing).")
trylock(::Store) = error("There is no well defined way to \"lock\" or \"request\" a Store without storing an element in it. Instead of attempting `lock` consider using `put!(::Store, ...)` or use a `Resource` instead of a `Store`. Think of `Resource` and `Container` as locks and of `Store` as channels. They block only if empty (on taking) or full (on storing).")

"""
    take!(::Store)

An alias for `get(::Store)` for easier interoperability with the `Base.Channel` interface. Blocks if the store is empty.
"""
take!(sto::Store, filter::Function=get_any_item; priority=0) = get(sto, filter; priority)

using ConcurrentSim

struct TestException <: Exception end

function test_callback(ev::AbstractEvent)
  println("Hi I timed out at $(now(ev))")
end

function test_callback_exception(ev::Event)
  throw(TestException())
end

sim = Simulation()
@callback test_callback(timeout(sim, 1))
@callback test_callback(timeout(sim, 3))
run(sim, 2)
sim = Simulation()
try
  run(sim, Event(sim))
catch exc
  println("$exc has been thrown!")
end
sim = Simulation(3)
start_time = now(sim)
@callback test_callback(timeout(sim, 1))
run(sim, start_time+2)
println(now(sim)-start_time)
sim = Simulation()
start_time = now(sim)
ev = Event(sim)
@callback test_callback_exception(ev)
succeed(ev)
try
  run(sim)
catch exc
  println("$exc has been thrown after $(now(sim)-start_time)!")
end

using ConcurrentSim
using ResumableFunctions

struct StoreObject
  i :: Int
end

@resumable function my_consumer(sim::Simulation, sto::Store)
  for j in 1:10
    @yield timeout(sim, rand())
    println("$(now(sim)), consumer is demanding object")
    obj = @yield get(sto) # "unofficially" deprecated
    println("$(now(sim)), consumer is being served with object ", obj.i)
  end
end

@resumable function my_producer(sim::Simulation, sto::Store)
  for j in 1:10
    println("$(now(sim)), producer is offering object $j")
    @yield put!(sto, StoreObject(j))
    println("$(now(sim)), producer is being served")
    @yield timeout(sim, 2*rand())
  end
end

sim = Simulation()
sto = Store{StoreObject}(sim)
@process my_consumer(sim, sto)
@process my_producer(sim, sto)
run(sim)

using ConcurrentSim

function test_callback(ev::Event)
  println("I am a callback function running in $(typeof(environment(ev)))")
end

sim = Simulation()
ev = Event(sim)
println(typeof(ev))
cb = @callback test_callback(ev)
remove_callback(cb, ev)
println(state(ev))
show(value(ev))
println()
succeed(ev, value="Hi")
@callback test_callback(ev)
println(state(ev))
println(value(ev))
run(sim)
try
  @callback test_callback(ev)
catch exc
  println("$exc has been thrown!")
end
println(state(ev))
println(value(ev))

using ConcurrentSim
using ResumableFunctions
using Dates

@resumable function datetimetest(sim::Simulation)
  println(nowDatetime(sim))
  @yield timeout(sim, Day(2))
  println(nowDatetime(sim))
end

datetime = now()
sim = Simulation(datetime)
@process datetimetest(sim)
run(sim, datetime+Month(3))
println(nowDatetime(sim))

using ConcurrentSim
using JET
using Test

using InteractiveUtils

@testset "JET checks" begin
    rep = report_package("ConcurrentSim";
        ignored_modules=(
            AnyFrameModule(InteractiveUtils),
        )
    )
    @show rep
    @test length(JET.get_reports(rep)) == 0 # use setup below in case there are warnings
    #@test_broken length(JET.get_reports(rep)) == 0
    #@test length(JET.get_reports(rep)) <= 123
end

abstract type AbstractProcess <: AbstractEvent end
abstract type DiscreteProcess <: AbstractProcess end

struct InterruptException <: Exception
  by :: AbstractProcess
  cause :: Any
end

struct EmptySchedule <: Exception end

struct EventKey
  time :: Float64
  priority :: Int
  id :: UInt
end

function isless(a::EventKey, b::EventKey) :: Bool
  (a.time < b.time) || (a.time === b.time && a.priority > b.priority) || (a.time === b.time && a.priority === b.priority && a.id < b.id)
end

mutable struct Simulation <: Environment
  time :: Float64
  heap :: DataStructures.PriorityQueue{BaseEvent, EventKey}
  eid :: UInt
  sid :: UInt
  active_proc :: Union{AbstractProcess, Nothing}
  function Simulation(initial_time::Number=zero(Float64))
    new(initial_time, DataStructures.PriorityQueue{BaseEvent, EventKey}(), zero(UInt), zero(UInt), nothing)
  end
end

function step(sim::Simulation)
  isempty(sim.heap) && throw(EmptySchedule())
  (bev, key) = DataStructures.first(sim.heap)
  DataStructures.popfirst!(sim.heap)
  sim.time = key.time
  bev.state = processed
  for callback in bev.callbacks
    callback()
  end
end

function now(sim::Simulation)
  sim.time
end

function now(ev::AbstractEvent)
  return now(environment(ev))
end

function active_process(sim::Simulation)
  sim.active_proc
end

function reset_active_process(sim::Simulation)
  sim.active_proc = nothing
end

function set_active_process(sim::Simulation, proc::AbstractProcess)
  sim.active_proc = proc
end

using Revise
using Documenter
using AnythingLLMDocs
using ResumableFunctions
using ConcurrentSim

DocMeta.setdocmeta!(ConcurrentSim, :DocTestSetup, :(using ConcurrentSim, ResumableFunctions); recursive=true)

doc_modules = [ConcurrentSim]

api_base="https://anythingllm.krastanov.org/api/v1"
anythingllm_assets = integrate_anythingllm(
  "ConcurrentSim",
  doc_modules,
  @__DIR__,
  api_base;
  repo = "github.com/JuliaDynamics/ConcurrentSim.jl.git",
  options = EmbedOptions(),
)

makedocs(
  sitename = "ConcurrentSim",
  authors = "Ben Lauwens and SimJulia & ConcurrentSim contributors",
  doctest = false,
  format = Documenter.HTML(assets = anythingllm_assets),
  pages    = [
    "Home" => "index.md",
    "Tutorial" => "tutorial.md",
    "Topical Guides" => [
        "Basics" => "guides/basics.md",
        "Environments" => "guides/environments.md",
        "Events" => "guides/events.md",
        "Resource API" => "guides/blockingandyielding.md",
        ],
    "Examples" => [
        "Ross" => "examples/ross.md",
        "Latency" => "examples/Latency.md",
        "Multi-server Queue" => "examples/mmc.md",
    ],
    "API" => "api.md"
  ]
)

deploydocs(
  repo = "github.com/JuliaDynamics/ConcurrentSim.jl.git"
)

using ConcurrentSim
using ResumableFunctions

@resumable function client(sim::Simulation, res::Resource, i::Int, priority::Int)
  println("$(now(sim)), client $i is waiting")
  @yield request(res, priority=priority) # deprecated
  println("$(now(sim)), client $i is being served")
  @yield timeout(sim, rand())
  println("$(now(sim)), client $i has been served")
  @yield release(res)
end

@resumable function generate(sim::Simulation, res::Resource)
  for i in 1:10
    @process client(sim, res, i, 10-i)
    @yield timeout(sim, 0.5*rand())
  end
end

sim = Simulation()
res = Resource(sim, 2; level=1)
println(res)
@process generate(sim, res)
run(sim)

@resumable function my_consumer(sim::Simulation, con::Container)
  for i in 1:10
    amount = 3*rand()
    println("$(now(sim)), consumer is demanding $amount")
    @yield timeout(sim, 1.0*rand())
    get_ev = get(con, amount)
    val = @yield get_ev | timeout(sim, rand())
    if val[get_ev].state == ConcurrentSim.processed
      println("$(now(sim)), consumer is being served, level is ", con.level)
      delay = 5.0*rand()
      @yield timeout(sim, delay)
    else
      println("$(now(sim)), consumer has timed out")
      cancel(con, get_ev)
    end
  end
end

@resumable function my_producer(sim::Simulation, con::Container)
  for i in 1:10
    amount = 2*rand()
    println("$(now(sim)), producer is offering $amount")
    @yield timeout(sim, 1.0*rand())
    @yield put(con, amount) # deprecated
    level = con.level
    println("$(now(sim)), producer is being served, level is ", level)
    delay = 5.0*rand()
    @yield timeout(sim, delay)
  end
end

sim = Simulation()
con = Container(sim, 10.0; level=5.0)
@process my_consumer(sim, con)
@process my_producer(sim, con)
run(sim)

using ConcurrentSim

struct TestException <: Exception end

function and_callback(ev::AbstractEvent)
  println("Both events are triggered: $(value(ev))")
end

function or_callback(ev::AbstractEvent)
  println("One of both events is triggered: $(value(ev))")
end

function or_callback_succeed(ev::AbstractEvent, ev2::AbstractEvent)
  println("One of both events is triggered: $(value(ev))")
  succeed(ev2)
end

function or_callback_fail(ev::AbstractEvent, ev2::AbstractEvent)
  println("One of both events is triggered: $(value(ev))")
  fail(ev2, TestException())
end

sim = Simulation()
ev1 = timeout(sim, 1)
ev2 = Event(sim)
@callback and_callback(ev1 & ev2)
@callback or_callback_succeed(ev1 | ev2, ev2)
run(sim)

sim = Simulation()
ev1 = timeout(sim, 1, value=TestException())
ev2 = Event(sim)
@callback or_callback_fail(ev1 | ev2, ev2)
@callback and_callback(ev1 & ev2)
run(sim)

sim = Simulation()
ev1 = timeout(sim)
ev2 = timeout(sim, value=TestException())
@callback or_callback(ev1 | ev2)
run(sim)

sim = Simulation()
ev1 = timeout(sim)
ev2 = timeout(sim)
@callback or_callback(ev1 | ev2)
run(sim)

sim = Simulation()
ev1 = timeout(sim, 1)
ev2 = Event(sim)
ev3 = timeout(sim, 2)
@callback and_callback(AllOf(ev1, ev2, ev3))
@callback or_callback_succeed(AnyOf(ev1, ev2, ev3), ev2)
run(sim)

sim = Simulation()
ev1 = timeout(sim, 1, value=TestException())
ev2 = Event(sim)
ev3 = Event(sim)
@callback or_callback_fail(AnyOf(ev1, ev2, ev3), ev2)
@callback and_callback(AllOf(ev1, ev2, ev3))
run(sim)

sim = Simulation()
ev1 = timeout(sim)
ev2 = timeout(sim, value=TestException())
ev3 = timeout(sim)
@callback or_callback(AnyOf(ev1, ev2, ev3))
run(sim)

sim = Simulation()
ev1 = timeout(sim)
ev2 = timeout(sim)
ev3 = timeout(sim)
@callback or_callback(AnyOf(ev1, ev2, ev3))
run(sim)

function Simulation(initial_time::DateTime)
  Simulation(Dates.datetime2epochms(initial_time))
end

function run(env::Environment, until::DateTime)
  run(env, Dates.datetime2epochms(until))
end

function timeout(env::Environment, delay::Period; priority=0, value=nothing)
  time = now(env)
  del = Dates.datetime2epochms(Dates.epochms2datetime(time)+delay)-time
  timeout(env, del; priority=Int(priority), value)
end

function nowDatetime(env::Environment)
  Dates.epochms2datetime(now(env))
end

using ConcurrentSim

struct TestException <: Exception end

function test_callback_event(ev::Event)
  println("Hi $ev has value $(value(ev))")
end

function test_callback_Timeout(ev::AbstractEvent)
  println("Hi $ev timed out at $(now(environment(ev)))")
end

sim = Simulation()
ev1 = Event(sim)
@callback test_callback_event(ev1)
succeed(ev1, value="Success")
ev2 = Event(sim)
@callback test_callback_event(ev2)
fail(ev2, TestException())
try
  succeed(ev2)
catch exc
  println("$exc has been thrown!")
end
@callback test_callback_Timeout(timeout(sim, 1))
run(sim)

struct StateValue
  state :: EVENT_STATE
  value :: Any
  function StateValue(state::EVENT_STATE, value::Any=nothing)
    new(state, value)
  end
end

struct Operator <: AbstractEvent
  bev :: BaseEvent
  eval :: Function
  function Operator(eval::Function, fev::AbstractEvent, events::AbstractEvent...)
    env = environment(fev)
    op = new(BaseEvent(env), eval)
    event_state_values = Dict{AbstractEvent, StateValue}()
    for ev in tuple(fev, events...)
      event_state_values[ev] = StateValue(state(ev))
      @callback check(ev, op, event_state_values)
    end
    op
  end
end

function check(ev::AbstractEvent, op::Operator, event_state_values::Dict{AbstractEvent, StateValue})
  val = value(ev)
  if state(op) === idle
    if isa(val, Exception)
      schedule(op; value=val)
    else
      event_state_values[ev] = StateValue(state(ev), val)
      op.eval(collect(values(event_state_values))) && schedule(op; value=event_state_values)
    end
  elseif state(op) === scheduled
    if isa(val, Exception)
      schedule(op; priority=typemax(Int), value=val)
    else
      event_state_values[ev] = StateValue(state(ev), val)
    end
  end
end

function eval_and(state_values::Vector{StateValue})
  all(map((sv)->sv.state === processed, state_values))
end

function eval_or(state_values::Vector{StateValue})
  any(map((sv)->sv.state === processed, state_values))
end

function (&)(ev1::AbstractEvent, ev2::AbstractEvent)
  Operator(eval_and, ev1, ev2)
end

function (|)(ev1::AbstractEvent, ev2::AbstractEvent)
  Operator(eval_or, ev1, ev2)
end

function AllOf(events...)
  Operator(eval_and,events...)
end

function AnyOf(events...)
  Operator(eval_or,events...)
end

using ConcurrentSim
using ResumableFunctions

struct TestException <: Exception end

@resumable function fibonnaci(sim::Simulation)
  a = 0
  b = 1
  while true
    println(a)
    @yield timeout(sim, 1)
    a, b = b, a+b
  end
end

@resumable function test_process(sim::Simulation, ev::AbstractEvent)
  @yield ev
end

@resumable function test_process_exception(sim::Simulation, ev::AbstractEvent)
  try
    value = @yield ev
  catch exc
    println("$exc has been thrown")
  end
end

@resumable function test_interrupter(sim::Simulation, proc::Process)
  @yield timeout(sim, 2)
  @yield interrupt(proc)
end

@resumable function test_interrupted(sim::Simulation)
  try
    @yield timeout(sim, 10)
  catch exc
    if isa(exc, ConcurrentSim.InterruptException)
      println("$(active_process(sim)) interrupted")
    end
  end
  @yield timeout(sim, 10)
  throw(TestException())
end

sim = Simulation()
@process fibonnaci(sim)
println(sim)
run(sim, 10)

sim = Simulation()
@process test_process(sim, succeed(Event(sim)))
run(sim)

sim = Simulation()
@process test_process_exception(sim, timeout(sim, 1, value=TestException()))
try
  run(sim)
catch exc
  println("$exc has been thrown")
end

sim = Simulation()
@process test_process_exception(sim, timeout(sim, value=TestException()))
run(sim)

sim = Simulation()
proc = @process test_interrupted(sim)
@process test_interrupter(sim, proc)
try
  run(sim)
catch exc
  println("$exc has been thrown")
end

using ResumableFunctions
using Test
using SafeTestsets

function doset(descr)
    if length(ARGS) == 0
        return true
    end
    for a in ARGS
        if occursin(lowercase(a), lowercase(descr))
            return true
        end
    end
    return false
end

macro doset(descr)
    quote
        if doset($descr)
            @safetestset $descr begin
                include("test_"*$descr*".jl")
            end
        end
    end
end

println("Starting tests with $(Threads.nthreads()) threads out of `Sys.CPU_THREADS = $(Sys.CPU_THREADS)`...")

@doset "base"
@doset "events"
@doset "operators"
@doset "simulations"
@doset "processes"
@doset "resources_containers"
@doset "resources_containers_deprecated"
@doset "resources_stores"
@doset "resources_stores_cast"
@doset "resources_stores_deprecated"
@doset "resources_fancy_stores"
@doset "resource_priorities"
@doset "utils_time"
VERSION >= v"1.9" && @doset "doctests"
VERSION >= v"1.9" && @doset "aqua"
get(ENV,"JET_TEST","")=="true" && @doset "jet"

struct Event <: AbstractEvent
  bev :: BaseEvent
  function Event(env::Environment)
    new(BaseEvent(env))
  end
end

function succeed(ev::Event; priority=0, value=nothing) :: Event
  state(ev) !== idle && throw(EventNotIdle(ev))
  schedule(ev; priority=Int(priority), value)
end

function fail(ev::Event, exc::Exception; priority=0) :: Event
  succeed(ev; priority=Int(priority), value=exc)
end

struct Timeout <: AbstractEvent
  bev :: BaseEvent
  function Timeout(env::Environment)
    new(BaseEvent(env))
  end
end

function timeout(env::Environment, delay::Number=0; priority=0, value::Any=nothing)
  schedule(Timeout(env), delay; priority=Int(priority), value)
end

function run(env::Environment, until::Number=Inf)
  run(env, timeout(env, until-now(env)))
end

# API

```@autodocs
Modules = [ConcurrentSim]
Private = false
```

```@docs
lock(res::Resource; priority=0)
unlock(res::Resource; priority=0)
take!(sto::Store, filter::Function=get_any_item; priority=0)
```

# Overview

ConcurrentSim is a discrete-event process-oriented simulation framework written in [Julia](http://julialang.org/) inspired by the Python library [SimPy](https://simpy.readthedocs.io/). Its process dispatcher is based on semi-coroutines scheduling as implemented in [ResumableFunctions](https://github.com/JuliaDynamics/ResumableFunctions.jl) or [ResumableFunctions](https://github.com/JuliaDynamics/ResumableFunctions.jl.git). A `Process` in ConcurrentSim is defined by a `@resumable function` yielding `Events`. ConcurrentSim provides three types of shared resources to model limited capacity congestion points: `Resources`, `Containers` and `Stores`. The API is modeled after the SimPy API but some specific Julia semantics are used.

The documentation contains a tutorial, topical guides explaining key concepts, a number of examples and the API reference. The tutorial, the topical guides and some examples are borrowed from SimPy to allow a direct comparison and an easy migration path for users. The differences between ConcurrentSim and SimPy are clearly documented.

`ConcurrentSim.jl` used to be known as `SimJulia.jl` until 2023. It is one of the longest-lived Julia packages.

## Example

A short example simulating two clocks ticking in different time intervals looks like this:

```jldoctest
julia> using ResumableFunctions

julia> using ConcurrentSim

julia> @resumable function clock(sim::Simulation, name::String, tick::Float64)
         while true
           println(name, " ", now(sim))
           @yield timeout(sim, tick)
         end
       end
clock (generic function with 1 method)

julia> sim = Simulation()
ConcurrentSim.Simulation time: 0.0 active_process: nothing

julia> @process clock(sim, "fast", 0.5)
ConcurrentSim.Process 1

julia> @process clock(sim, "slow", 1.0)
ConcurrentSim.Process 3

julia> run(sim, 2)
fast 0.0
slow 0.0
fast 0.5
slow 1.0
fast 1.0
fast 1.5
```

# Blocking and Yielding Resource API

The goal of this page is to list the most common synchronization and resource management patterns used in `ConcurrentSim.jl` simulations and to briefly compare them to Julia's base capabilities for asynchronous and parallel programming.

There are many different approaches to discrete event simulation in particular and to asynchronous and parallel programming in general. This page assumes some rudimentary understanding of concurrency in programming. While not necessary, you are encouraged to explore the following resources for a more holistic understanding:

- "concurrency" vs "parallelism" - see [stackoverflow.com](https://stackoverflow.com/questions/1050222/what-is-the-difference-between-concurrency-and-parallelism) on the topic;
- "threads" vs "tasks": A task is the actual piece of work, a thread is the "runway" on which a task runs. You can have more tasks than threads and you can even have tasks that jump between threads - see Julia's [parallel programming documentation](https://docs.julialang.org/en/v1/manual/parallel-computing/) (in particular the [async](https://docs.julialang.org/en/v1/manual/asynchronous-programming/) and [multithreading](https://docs.julialang.org/en/v1/manual/multi-threading/) docs), and multiple Julia blog post on [multithreading](https://julialang.org/blog/2019/07/multithreading/) and [its misuses](https://julialang.org/blog/2023/07/PSA-dont-use-threadid/);
- "locks" used to guard (or synchronize) the access to a given resource: i.e. one threads locks an array while modifying it in order to ensure that another thread will not be modifying it at the same time. Julia's `Base` multithreading capabilities provide a `ReentrantLock`, together with a `lock`, `trylock`, `unlock`, and `islocked` API;
- "channels" used to organize concurrent tasks. Julia's `Base` multithreading capabilities provide `Channel`, together with `take!`, `put!`, `isready`;
- knowing of the ["red/blue-colored functions" metaphor](https://journal.stuffwithstuff.com/2015/02/01/what-color-is-your-function/) can be valuable as well as learning of "promises" and "futures".

Programming discrete event simulations can be very similar to async parallel programming, except for the fact that in the simulation the "time" is fictitious (and tracking it is a big part of the value proposition in the simulation software). On the other hand, in usual parallel programming the goal is simply to do as much work as possible in the shortest (actual) time. In that context, one possible use of discrete event simulations is to cheaply model and optimize various parallel implementations of actual expensive algorithms (whether numerical computer algorithms or the algorithms used to schedule a real factory or a fleet of trucks).

In particular, the `ConcurrentSim.jl` package uses the async "coroutines" model of parallel programing. `ConcurrentSim` uses the `ResumableFunctions.jl` package to build its coroutines, which uses the `@resumable` macro to mark a function as an "async" coroutine and the `@yield` macro to yield between coroutines.

!!! warning "Base Julia coroutines vs ConcurrentSim coroutines"
    The `ConcurrentSim` and `ResumableFunctions` coroutines are currently incompatible with Julia's base coroutines (which based around `wait` and `fetch`). A separate coroutines implementation was necessary, because Julia's coroutines are designed for computationally heavy tasks and practical parallel algorithms, leading to significant overhead when they are used with extremely large numbers of computationally cheap tasks, as it is common in discrete event simulators. `ResumableFunctions`'s coroutines are single threaded but with drastically lower call overhead.
    A future long-term goal of ours is to unify the API used by `ResumableFunctions` and base Julia, but this will not be achieved in the near term, hence the need for pages like this one.

Without further ado, here is the typical API used with:

- `ConcurrentSim.Resource` which is used to represent scarce resource that can be used by only up to a fixed number of tasks. If the limit is just one task (the default), this is very similar to `Base.ReentrantLock`. `Resource` is a special case of `Container` with an integer "resource counter".
- `ConcurrentSim.Store` which is used to represent an unordered heap. For the ordered versions, consider `QueueStore` or `StackStore`.

```@raw html
<div style="width:120%;min-width:120%;">
```

||`Base` `ReentrantLock`|`Base` `Channel`|`ConcurrentSim` `Container`|`ConcurrentSim` `Resource`, i.e. `Container{Int}`|`ConcurrentSim` `Store`||
|---|:---|:---|:---|:---|:---|:---:|
|`put!`|❌|❌|@yield|@yield|@yield|low-level "put an object in" API|
|`take!`|❌|block|❌|❌|@yield|the `Channel`-like API for `Store`|
|`lock`|block|❌|❌|@yield|❌|the `Lock`-like API for `Resource` (there is also `trylock`)|
|`unlock`|✔️|❌|❌|@yield|❌|the `Lock`-like API for `Resource`|
|`isready`|❌|✔️|✔️|✔️|✔️|something is stored in the resource|
|`islocked`|✔️|❌|✔️|✔️|✔️|the resource can not store anything more|

```@raw html
</div>
```

The table denotes which methods exist (✔️), are blocking (block), need to be explicitly yielded with `ResumableFunctions` (@yield), or are not applicable (❌).

As you can see `Resource` shares some properties with `ReentrantLock` and avails itself of the `lock`/`unlock`/`trylock` Base API. `Store` similarly shares some properties with `Channel` and shares the `put!`/`take!` Base API. Of note is that when the Base API would be blocking, the corresponding `ConcurrentSim` methods actually give coroutines that need to be `@yield`-ed.

`take!` and `unlock` are both implemented on top of the lower level `get`.

The `Base.lock` and `Base.unlock` are aliased to `ConcurrentSim.request` and `ConcurrentSim.release` respectively for semantic convenience when working with `Resource`. 

`unlock(::Resource)` is instantaneous so the `@yield` is not strictly necessary. Similarly for `put!(::Store)` if the store has infinite capacity.

# ConcurrentSim basics

This guide describes the basic concepts of ConcurrentSim: How does it work? What are processes, events and the environment? What can I do with them?

## How ConcurrentSim works

If you break ConcurrentSim down, it is just an asynchronous event dispatcher. You generate events and schedule them at a given simulation time. Events are sorted by priority, simulation time, and an increasing event id. An event also has a list of callbacks, which are executed when the event is triggered and processed by the event loop. Events may also have a return value.

The components involved in this are the `Environment`, events and the process functions that you write.

Process functions implement your simulation model, that is, they define the behavior of your simulation. They are `@resumable` functions that `@yield` instances of `AbstractEvent`.

The environment stores these events in its event list and keeps track of the current simulation time.

If a process function yields an event, ConcurrentSim adds the process to the event’s callbacks and suspends the process until the event is triggered and processed. When a process waiting for an event is resumed, it will also receive the event’s value.

Here is a very simple example that illustrates all this:

```jldoctest
using ResumableFunctions
using ConcurrentSim

@resumable function example(env::Environment)
  event = timeout(env, 1, value=42)
  value = @yield event
  println("now=", now(env), ", value=", value)
end

sim = Simulation()
@process example(sim)
run(sim)

# output

now=1.0, value=42
```

The `example` process function above first creates a `timeout` event. It passes the environment, a delay, and a value to it. The `timeout` schedules itself at `now + delay` (that’s why the environment is required); other event types usually schedule themselves at the current simulation time.

The process function then yields the event and thus gets suspended. It is resumed, when ConcurrentSim processes the `timeout` event. The process function also receives the event’s value (42) – this is, however, optional, so `@yield event` would have been okay if the you were not interested in the value or if the event had no value at all.

Finally, the process function prints the current simulation time (that is accessible via the `now` function) and the `timeout`’s value.

If all required process functions are defined, you can instantiate all objects for your simulation. In most cases, you start by creating an instance of `Environment`, e.g. a `Simulation`, because you’ll need to pass it around a lot when creating everything else.

Starting a process function involves two things:

- You have to call the macro `@process` with as argument a call to the process function. (This will not execute any code of that function yet.) This will schedule an initialisation event at the current simulation time which starts the execution of the process function. The process instance is also an event that is triggered when the process function returns.
- Finally, you can start ConcurrentSim’s event loop. By default, it will run as long as there are events in the event list, but you can also let it stop earlier by providing an until argument.

# Tutorial

## Basic Concepts

ConcurrentSim is a discrete-event simulation library. The behavior of active components (like vehicles, customers or messages) is modeled with processes. All processes live in an environment. They interact with the environment and with each other via events.

Processes are described by `@resumable` functions. You can call them process function. During their lifetime, they create events and `@yield` them in order to wait for them to be triggered.

!!! note
    Detailed information about the `@resumable` and the `@yield` macros can be found in the documentation of [ResumableFunctions](https://github.com/JuliaDynamics/ResumableFunctions.jl.git).

When a process yields an event, the process gets suspended. ConcurrentSim resumes the process, when the event occurs (we say that the event is triggered). Multiple processes can wait for the same event. ConcurrentSim resumes them in the same order in which they yielded that event.

An important event type is the `timeout`. Events of this type are scheduled after a certain amount of (simulated) time has passed. They allow a process to sleep (or hold its state) for the given time. A `timeout` and all other events can be created by calling a constructor having the environment as first argument.

## Our First Process

Our first example will be a car process. The car will alternately drive and park for a while. When it starts driving (or parking), it will print the current simulation time.

So let’s start:

```jldoctest
julia> using ResumableFunctions

julia> using ConcurrentSim

julia> @resumable function car(env::Environment)
           while true
             println("Start parking at ", now(env))
             parking_duration = 5
             @yield timeout(env, parking_duration)
             println("Start driving at ", now(env))
             trip_duration = 2
             @yield timeout(env, trip_duration)
           end
         end
car (generic function with 1 method)
```

Our car process requires a reference to an `Environment` in order to create new events. The car‘s behavior is described in an infinite loop. Remember, the `car` function is a `@resumable` function. Though it will never terminate, it will pass the control flow back to the simulation once a `@yield` statement is reached. Once the yielded event is triggered (“it occurs”), the simulation will resume the function at this statement.

As said before, our car switches between the states parking and driving. It announces its new state by printing a message and the current simulation time (as returned by the function call `now`). It then calls the constructor `timeout` to create a timeout event. This event describes the point in time the car is done parking (or driving, respectively). By yielding the event, it signals the simulation that it wants to wait for the event to occur.

Now that the behavior of our car has been modeled, lets create an instance of it and see how it behaves:

```@meta
DocTestSetup = quote
  using ResumableFunctions
  using ConcurrentSim

  @resumable function car(env::Environment)
    while true
      println("Start parking at ", now(env))
      parking_duration = 5
      @yield timeout(env, parking_duration)
      println("Start driving at ", now(env))
      trip_duration = 2
      @yield timeout(env, trip_duration)
    end
  end
end
```

```jldoctest
julia> sim = Simulation()
ConcurrentSim.Simulation time: 0.0 active_process: nothing

julia> @process car(sim)
ConcurrentSim.Process 1

julia> run(sim, 15)
Start parking at 0.0
Start driving at 5.0
Start parking at 7.0
Start driving at 12.0
Start parking at 14.0
```

```@meta
DocTestSetup = nothing
```

The first thing we need to do is to create an environment, e.g. an instance of `Simulation`. The macro `@process` having as argument a car process function call creates a process that is initialized and added to the environment automatically.

Note, that at this time, none of the code of our process function is being executed. Its execution is merely scheduled at the current simulation time.

The `Process` returned by the `@process` macro can be used for process interactions.

Finally, we start the simulation by calling `run` and passing an end time to it.

## Process Interaction

The `Process` instance that is returned by `@process` macro can be utilized for process interactions. The two most common examples for this are to wait for another process to finish and to interrupt another process while it is waiting for an event.

### Waiting for a Process

As it happens, a ConcurrentSim `Process` can be used like an event. If you yield it, you are resumed once the process has finished. Imagine a car-wash simulation where cars enter the car-wash and wait for the washing process to finish, or an airport simulation where passengers have to wait until a security check finishes.

Lets assume that the car from our last example is an electric vehicle. Electric vehicles usually take a lot of time charging their batteries after a trip. They have to wait until their battery is charged before they can start driving again.

We can model this with an additional charge process for our car. Therefore, we redefine our `car` process function and add a `charge` process function.

A new charge process is started every time the vehicle starts parking. By yielding the `Process` instance that the `@process` macro returns, the `run` process starts waiting for it to finish:

```jldoctest
julia> using ResumableFunctions

julia> using ConcurrentSim

julia> @resumable function charge(env::Environment, duration::Number)
         @yield timeout(env, duration)
       end
charge (generic function with 1 method)

julia> @resumable function car(env::Environment)
         while true
           println("Start parking and charging at ", now(env))
           charge_duration = 5
           charge_process = @process charge(sim, charge_duration)
           @yield charge_process
           println("Start driving at ", now(env))
           trip_duration = 2
           @yield timeout(sim, trip_duration)
         end
       end
car (generic function with 1 method)
```

```@meta
DocTestSetup = quote
  using ResumableFunctions

  using ConcurrentSim

  @resumable function charge(env::Environment, duration::Number)
    @yield timeout(env, duration)
  end

  @resumable function car(env::Environment)
    while true
      println("Start parking and charging at ", now(env))
      charge_duration = 5
      charge_process = @process charge(sim, charge_duration)
      @yield charge_process
      println("Start driving at ", now(env))
      trip_duration = 2
      @yield timeout(sim, trip_duration)
    end
  end
end
```

Starting the simulation is straightforward again: We create a `Simulation`, one (or more) cars and finally call `run`.

```jldoctest
julia> sim = Simulation()
ConcurrentSim.Simulation time: 0.0 active_process: nothing

julia> @process car(sim)
ConcurrentSim.Process 1

julia> run(sim, 15)
Start parking and charging at 0.0
Start driving at 5.0
Start parking and charging at 7.0
Start driving at 12.0
Start parking and charging at 14.0
```

```@meta
DocTestSetup = nothing
```

### Interrupting Another Process

Imagine, you don’t want to wait until your electric vehicle is fully charged but want to interrupt the charging process and just start driving instead.

ConcurrentSim allows you to interrupt a running process by calling the `interrupt` function:

```jldoctest
julia> using ResumableFunctions

julia> using ConcurrentSim

julia> @resumable function driver(env::Environment, car_process::Process)
         @yield timeout(env, 3)
         @yield interrupt(car_process)
       end
driver (generic function with 1 method)
```

The driver process has a reference to the car process. After waiting for 3 time steps, it interrupts that process.

Interrupts are thrown into process functions as `Interrupt` exceptions that can (should) be handled by the interrupted process. The process can then decide what to do next (e.g., continuing to wait for the original event or yielding a new event):

```@meta
DocTestSetup = quote
  using ResumableFunctions
  using ConcurrentSim
end
```

```jldoctest
julia> @resumable function charge(env::Environment, duration::Number)
         @yield timeout(env, duration)
       end
charge (generic function with 1 method)

julia> @resumable function car(env::Environment)
         while true
           println("Start parking and charging at ", now(env))
           charge_duration = 5
           charge_process = @process charge(sim, charge_duration)
           try
             @yield charge_process
           catch
             println("Was interrupted. Hopefully, the battery is full enough ...")
           end
           println("Start driving at ", now(env))
           trip_duration = 2
           @yield timeout(sim, trip_duration)
         end
       end
car (generic function with 1 method)
```

When you compare the output of this simulation with the previous example, you’ll notice that the car now starts driving at time 3 instead of 5:

```@meta
DocTestSetup = quote
  using ResumableFunctions
  using ConcurrentSim

  @resumable function driver(env::Environment, car_process::Process)
    @yield timeout(env, 3)
    @yield interrupt(car_process)
  end

  @resumable function charge(env::Environment, duration::Number)
    @yield timeout(env, duration)
  end

  @resumable function car(env::Environment)
    while true
      println("Start parking and charging at ", now(env))
      charge_duration = 5
      charge_process = @process charge(sim, charge_duration)
      try
        @yield charge_process
      catch
        println("Was interrupted. Hopefully, the battery is full enough ...")
      end
      println("Start driving at ", now(env))
      trip_duration = 2
      @yield timeout(sim, trip_duration)
    end
  end
end
```

```jldoctest
julia> sim = Simulation()
ConcurrentSim.Simulation time: 0.0 active_process: nothing

julia> car_process = @process car(sim)
ConcurrentSim.Process 1

julia> @process driver(sim, car_process)
ConcurrentSim.Process 3

julia> run(sim, 15)
Start parking and charging at 0.0
Was interrupted. Hopefully, the battery is full enough ...
Start driving at 3.0
Start parking and charging at 5.0
Start driving at 10.0
Start parking and charging at 12.0
```

```@meta
DocTestSetup = nothing
```

## Shared Resources

ConcurrentSim offers three types of resources that help you modeling problems, where multiple processes want to use a resource of limited capacity (e.g., cars at a fuel station with a limited number of fuel pumps) or classical producer-consumer problems.

In this section, we’ll briefly introduce ConcurrentSim’s `Resource` class.

### Basic Resource Usage

We’ll slightly modify our electric vehicle process `car` that we introduced in the last sections.

The car will now drive to a battery charging station (BCS) and request (lock) one of its two charging spots. If both of these spots are currently in use, it waits until one of them becomes available again. It then starts charging its battery and leaves the station afterwards:

```jldoctest
julia> using ResumableFunctions

julia> using ConcurrentSim

julia> @resumable function car(env::Environment, name::Int, bcs::Resource, driving_time::Number, charge_duration::Number)
         @yield timeout(sim, driving_time)
         println(name, " arriving at ", now(env))
         @yield request(bcs)
         println(name, " starting to charge at ", now(env))
         @yield timeout(sim, charge_duration)
         println(name, " leaving the bcs at ", now(env))
         @yield unlock(bcs)
       end
car (generic function with 1 method)
```

The resource’s `request` function generates an event that lets you wait until the resource becomes available again. If you are resumed, you “own” the resource until you release it with `unlock`.

You are responsible to call `unlock` once you are done using the resource. When you unlock (release) a resource, the next waiting process is resumed and now “owns” one of the resource’s slots. The basic `Resource` sorts waiting processes in a FIFO (first in—first out) way.

A resource needs a reference to an `Environment` and a capacity when it is created:

```@meta
DocTestSetup = quote
  using ResumableFunctions
  using ConcurrentSim

  @resumable function car(env::Environment, name::Int, bcs::Resource, driving_time::Number, charge_duration::Number)
    @yield timeout(sim, driving_time)
    println(name, " arriving at ", now(env))
    @yield request(bcs)
    println(name, " starting to charge at ", now(env))
    @yield timeout(sim, charge_duration)
    println(name, " leaving the bcs at ", now(env))
    @yield unlock(bcs)
  end
end
```

```jldoctest
julia> sim = Simulation()
ConcurrentSim.Simulation time: 0.0 active_process: nothing

julia> bcs = Resource(sim, 2)
ConcurrentSim.Resource
```

We can now create the car processes and pass a reference to our resource as well as some additional parameters to them

```@meta
DocTestSetup = quote
  using ResumableFunctions
  using ConcurrentSim

  @resumable function car(env::Environment, name::Int, bcs::Resource, driving_time::Number, charge_duration::Number)
    @yield timeout(sim, driving_time)
    println(name, " arriving at ", now(env))
    @yield request(bcs)
    println(name, " starting to charge at ", now(env))
    @yield timeout(sim, charge_duration)
    println(name, " leaving the bcs at ", now(env))
    @yield unlock(bcs)
  end

  sim = Simulation()
  bcs = Resource(sim, 2)
end
```

```jldoctest
julia> for i in 1:4
         @process car(sim, i, bcs, 2i, 5)
       end

julia> run(sim)
1 arriving at 2.0
1 starting to charge at 2.0
2 arriving at 4.0
2 starting to charge at 4.0
3 arriving at 6.0
1 leaving the bcs at 7.0
3 starting to charge at 7.0
4 arriving at 8.0
2 leaving the bcs at 9.0
4 starting to charge at 9.0
3 leaving the bcs at 12.0
4 leaving the bcs at 14.0
```

Finally, we can start the simulation. Since the car processes all terminate on their own in this simulation, we don’t need to specify an until time — the simulation will automatically stop when there are no more events left:

```@meta
DocTestSetup = quote
  using ResumableFunctions
  using ConcurrentSim

  @resumable function car(env::Environment, name::Int, bcs::Resource, driving_time::Number, charge_duration::Number)
    @yield timeout(sim, driving_time)
    println(name, " arriving at ", now(env))
    @yield request(bcs)
    println(name, " starting to charge at ", now(env))
    @yield timeout(sim, charge_duration)
    println(name, " leaving the bcs at ", now(env))
    @yield unlock(bcs)
  end

  sim = Simulation()
  bcs = Resource(sim, 2)
  for i in 1:4
    @process car(sim, i, bcs, 2i, 5)
  end
end
```

```jldoctest
julia> run(sim)
1 arriving at 2.0
1 starting to charge at 2.0
2 arriving at 4.0
2 starting to charge at 4.0
3 arriving at 6.0
1 leaving the bcs at 7.0
3 starting to charge at 7.0
4 arriving at 8.0
2 leaving the bcs at 9.0
4 starting to charge at 9.0
3 leaving the bcs at 12.0
4 leaving the bcs at 14.0
```

```@meta
DocTestSetup = nothing
```

Note that the first two cars can start charging immediately after they arrive at the BCS, while cars 3 and 4 have to wait.

# Events

ConcurrentSim includes an extensive set of event types for various purposes. All of them are descendants of `AbstractEvent`. Here the following events are discussed:

- `Event`
- `timeout`
- `Operator`

The guide to resources describes the various resource events.

## Event basics

ConcurrentSim events are very similar – if not identical — to deferreds, futures or promises. Instances of the type AbstractEvent are used to describe any kind of events. Events can be in one of the following states. An event:

- might happen (idle),
- is going to happen (scheduled) or
- has happened (processed).

They traverse these states exactly once in that order. Events are also tightly bound to time and time causes events to advance their state.

Initially, events are idle and the function `state` returns `ConcurrentSim.idle`.

If an event gets scheduled at a given time, it is inserted into ConcurrentSim’s event queue. The function `state` returns `ConcurrentSim.scheduled`.

As long as the event is not processed, you can add callbacks to an event. Callbacks are function having an `AbstractEvent` as first parameter.

An event becomes processed when ConcurrentSim pops it from the event queue and calls all of its callbacks. It is now no longer possible to add callbacks. The function `state` returns `ConcurrentSim.processed`.

Events also have a value. The value can be set before or when the event is scheduled and can be retrieved via the function `value` or, within a process, by yielding the event (`value = @yield event`).

## Adding callbacks to an event

“What? Callbacks? I’ve never seen no callbacks!”, you might think if you have worked your way through the tutorial.

That’s on purpose. The most common way to add a callback to an event is yielding it from your process function (`@yield event`). This will add the process’ `resume` function as a callback. That’s how your process gets resumed when it yielded an event.

However, you can add any function to the list of callbacks as long as it accepts `AbstractEvent` or a descendant as first parameter:

```jldoctest
julia> using ConcurrentSim

julia> function my_callback(ev::AbstractEvent)
         println("Called back from ", ev)
       end
my_callback (generic function with 1 method)

julia> sim = Simulation()
ConcurrentSim.Simulation time: 0.0 active_process: nothing

julia> ev = Event(sim)
ConcurrentSim.Event 1

julia> @callback my_callback(ev);

julia> succeed(ev)
ConcurrentSim.Event 1

julia> run(sim)
Called back from ConcurrentSim.Event 1
```

## Example usages of Event

The simple mechanics outlined above provide a great flexibility in the way events can be used.

One example for this is that events can be shared. They can be created by a process or outside of the context of a process. They can be passed to other processes and chained. 

Below we give such an example, however this is a **very low-level example** and you would probably prefer to use the safer and more user-friendly [`Resource`](@ref) or [`Store`](@ref).

```jldoctest
using ResumableFunctions
using ConcurrentSim

mutable struct School
  class_ends :: Event
  pupil_procs :: Vector{Process}
  bell_proc :: Process
  function School(env::Simulation)
    school = new()
    school.class_ends = Event(env)
    school.pupil_procs = Process[@process pupil(env, school, i) for i=1:3]
    school.bell_proc = @process bell(env, school)
    return school
  end
end

@resumable function bell(env::Simulation, school::School)
  for i=1:2
    println("starting the bell timer at t=$(now(env))")
    @yield timeout(env, 45.0)
    succeed(school.class_ends)
    school.class_ends = Event(env) # the event is now idle (i.e. spent) so we need to create a new one
    println("bell is ringing at t=$(now(env))")
  end
end

@resumable function pupil(env::Simulation, school::School, pupil)
  for i=1:2
    println("pupil $pupil goes to class")
    @yield school.class_ends
    println("pupil $pupil leaves class at t=$(now(env))")
  end
end

env = Simulation()
school = School(env)
run(env)

# output

pupil 1 goes to class
pupil 2 goes to class
pupil 3 goes to class
starting the bell timer at t=0.0
bell is ringing at t=45.0
starting the bell timer at t=45.0
pupil 1 leaves class at t=45.0
pupil 1 goes to class
pupil 2 leaves class at t=45.0
pupil 2 goes to class
pupil 3 leaves class at t=45.0
pupil 3 goes to class
bell is ringing at t=90.0
pupil 1 leaves class at t=90.0
pupil 2 leaves class at t=90.0
pupil 3 leaves class at t=90.0
```

# Environments

A simulation environment manages the simulation time as well as the scheduling and processing of events. It also provides means to step through or execute the simulation.

The base type for all environments is `Environment`. “Normal” simulations use its subtype `Simulation`.

## Simulation control

ConcurrentSim is very flexible in terms of simulation execution. You can run your simulation until there are no more events, until a certain simulation time is reached, or until a certain event is triggered. You can also step through the simulation event by event. Furthermore, you can mix these things as you like.

For example, you could run your simulation until an interesting event occurs. You could then step through the simulation event by event for a while; and finally run the simulation until there are no more events left and your processes have all terminated.

The most important function here is `run`:

- If you call it with an instance of the environment as the only argument  (`run(env)`), it steps through the simulation until there are no more events left. If your processes run forever, this function will never terminate (unless you kill your script by e.g., pressing `Ctrl-C`).

- In most cases it is advisable to stop your simulation when it reaches a certain simulation time. Therefore, you can pass the desired time via a second argument, e.g.: `run(env, 10)`.

  The simulation will then stop when the internal clock reaches 10 but will not process any events scheduled for time 10. This is similar to a new environment where the clock is 0 but (obviously) no events have yet been processed.

  If you want to integrate your simulation in a GUI and want to draw a process bar, you can repeatedly call this function with increasing until values and update your progress bar after each call:

```julia
sim = Simulation()
for t in 1:100
  run(sim, t)
  update(progressbar, t)
end
```

- Instead of passing a number as second argument to `run`, you can also pass any event to it. `run` will then return when the event has been processed.

  Assuming that the current time is 0, `run(env, timeout(env, 5))` is equivalent to `run(env, 5)`.

  You can also pass other types of events (remember, that a `Process` is an event, too):

```jldoctest
using ResumableFunctions
using ConcurrentSim

@resumable function my_process(env::Environment)
  @yield timeout(env, 1)
  "Monty Python's Flying Circus"
end

sim = Simulation()
proc = @process my_process(sim)
run(sim, proc)

# output

"Monty Python's Flying Circus"
```

To step through the simulation event by event, the environment offers `step`. This function processes the next scheduled event. It raises an `EmptySchedule` exception if no event is available.

In a typical use case, you use this function in a loop like:
```julia
while now(sim) < 10
  step(sim)
end
```

## State access

The environment allows you to get the current simulation time via the function `now`. The simulation time is a number without unit and is increased via `timeout` events.

By default, the simulation starts at time 0, but you can pass an `initial_time` to the `Simulation` constructor to use something else.

Note

!!! note
    Although the simulation time is technically unitless, you can pretend that it is, for example, in milliseconds and use it like a timestamp returned by `Base.Dates.datetime2epochm` to calculate a date or the day of the week. The `Simulation` constructor and the `run` function accept as argument a `Base.Dates.DateTime` and the `timeout` constructor a `Base.Dates.Delay`. Together with the convenience function `nowDateTime` a simulation can transparently schedule its events in seconds, minutes, hours, days, ...

The function `active_process` is comparable to `Base.Libc.getpid` and returns the current active `Process`. If no process is active, a `NullException` is thrown. A process is active when its process function is being executed. It becomes inactive (or suspended) when it yields an event.

Thus, it only makes sense to call this function from within a process function or a function that is called by your process function:

```jldoctest
julia> using ResumableFunctions

julia> using ConcurrentSim

julia> function subfunc(env::Environment)
         println(active_process(env))
       end
subfunc (generic function with 1 method)

julia> @resumable function my_proc(env::Environment)
         while true
           println(active_process(env))
           subfunc(env)
           @yield timeout(env, 1)
         end
       end
my_proc (generic function with 1 method)

julia> sim = Simulation()
ConcurrentSim.Simulation time: 0.0 active_process: nothing

julia> @process my_proc(sim)
ConcurrentSim.Process 1

julia> isnothing(active_process(sim))
true

julia> ConcurrentSim.step(sim)
ConcurrentSim.Process 1
ConcurrentSim.Process 1

julia> isnothing(active_process(sim))
true
```

An exemplary use case for this is the resource system: If a process function calls `request` to request (lock) a `Resource`, the resource determines the requesting process via `active_process`.

## Miscellaneous

A generator function can have a return value:

```julia
@resumable function my_proc(env::Environment)
  @yield timeout(sim, 1)
  150
end
```

In ConcurrentSim, this can be used to provide return values for processes that can be used by other processes:

```julia
@resumable function other_proc(env::Environment)
  ret_val = @yield @process my_proc(env)
  @assert ret_val == 150
end
```

# Event Latency

There is a built-in [`DelayQueue`](@ref) if you need a store [`Store`](@ref) with latency between `put!` and `take!` events. However here, we show you how you could have built one for yourself. If you modify this in order to construct a particularly useful type of latency store, please contribute it to the library through a pull request.

## Description 
In this example we show how to separate the time delay between processes from the processes themselves. We model a communications channel, called a `Cable`, where a sender sends messages regularly each `SEND_PERIOD` time units and a receiver listens each `RECEIVE_PERIOD`. The messages in the cable have a delay of `DELAY_DURATION` until they reach the receiver.

### Load Packages


```jldoctest 1; output = false
using ConcurrentSim
using ResumableFunctions
import Base: put!, take!

# output
```

### Define Constants


```jldoctest 1; output = false
const SIM_DURATION = 100.
const SEND_PERIOD = 5.0
const RECEIVE_PERIOD = 3.0;

nothing # hide

# output
```

### Define Cable model
The `Cable` contains reference to the simulation it is part of, the delay that messages experience, and a store that contains the sent messages


```jldoctest 1; output = false
mutable struct Cable
    env::Simulation
    delay::Float64
    store::Store{String}
    
    function Cable(env::Simulation, delay::Float64)
        return new(env, delay, Store{String}(env))
    end
end;

nothing # hide

# output
```

The latency function is a generator which yields two events: first a `timeout` that represents the transmission delay, then a put event when the message gets stored in the store.


```jldoctest 1; output = false
@resumable function latency(env::Simulation, cable::Cable, value::String)
    @yield timeout(cable.env, cable.delay)
    @yield put!(cable.store, value)
end;

nothing # hide

# output
```

The `put!` and `take!` functions allow interaction with the cable (note that these are not `@resumable` because they need to return the result of the operation and not the operation itself).


```jldoctest 1; output = false 
function put!(cable::Cable, value::String)
    @process latency(cable.env, cable, value) # results in the scheduling of all events generated by latency
end

function take!(cable::Cable); output = false
    take!(cable.store) # returns an element stored in the cable store
end;

nothing # hide

# output
```

The `sender` and `receiver` generators yield events to the simulator.


```jldoctest 1; output = false
@resumable function sender(env::Simulation, cable::Cable)
    while true
        @yield timeout(env, SEND_PERIOD)
        value = "sender sent this at $(now(env))"
        put!(cable, value)
    end
end

@resumable function receiver(env::Simulation, cable::Cable)
    while true
        @yield timeout(env, RECEIVE_PERIOD)
        msg = @yield take!(cable)
        println("Received this at $(now(env)) while $msg")
    end
end;

nothing # hide

# output
```

Create simulation, register events, and run!


```jldoctest 1
env = Simulation()
cable = Cable(env, 10.)
@process sender(env, cable)
@process receiver(env, cable)

run(env, SIM_DURATION)

# output

Received this at 15.0 while sender sent this at 5.0
Received this at 20.0 while sender sent this at 10.0
Received this at 25.0 while sender sent this at 15.0
Received this at 30.0 while sender sent this at 20.0
Received this at 35.0 while sender sent this at 25.0
Received this at 40.0 while sender sent this at 30.0
Received this at 45.0 while sender sent this at 35.0
Received this at 50.0 while sender sent this at 40.0
Received this at 55.0 while sender sent this at 45.0
Received this at 60.0 while sender sent this at 50.0
Received this at 65.0 while sender sent this at 55.0
Received this at 70.0 while sender sent this at 60.0
Received this at 75.0 while sender sent this at 65.0
Received this at 80.0 while sender sent this at 70.0
Received this at 85.0 while sender sent this at 75.0
Received this at 90.0 while sender sent this at 80.0
Received this at 95.0 while sender sent this at 85.0
```

# Ross, Simulation 5th edition:
  
## A repair problem

### Source

Ross, Simulation 5th edition, Section 7.7, p. 124-126

### Description

A system needs $n$ working machines to be operational. To guard against machine breakdown, additional machines are kept available as spares. Whenever a machine breaks down it is immediately replaced by a spare and is itself sent to the repair facility, which consists of a single repairperson who repairs failed machines one at a time. Once a failed machine has been repaired it becomes available as a spare to be used when the need arises. All repair times are independent random variables having the common distribution function $G$. Each time a machine is put into use the amount of time it functions before breaking down is a random variable, independent of the past, having distribution function $F$.

The system is said to “crash” when a machine fails and no spares are available. Assuming that there are initially $n + s$ functional machines of which $n$ are put in use and $s$ are kept as spares, we are interested in simulating this system so as to approximate $E[T]$, where $T$ is the time at which the system crashes.

### Code

```jldoctest
using ResumableFunctions
using ConcurrentSim

using Distributions
using Random
using StableRNGs

const RUNS = 5
const N = 10
const S = 3
const SEED = 150
const LAMBDA = 100
const MU = 1

const rng = StableRNG(42) # setting a random seed for reproducibility
const F = Exponential(LAMBDA)
const G = Exponential(MU)

@resumable function machine(env::Environment, repair_facility::Resource, spares::Store{Process})
    while true
        try @yield timeout(env, Inf) catch end
        @yield timeout(env, rand(rng, F))
        get_spare = take!(spares)
        @yield get_spare | timeout(env)
        if state(get_spare) != ConcurrentSim.idle 
            @yield interrupt(value(get_spare))
        else
            throw(StopSimulation("No more spares!"))
        end
        @yield request(repair_facility)
        @yield timeout(env, rand(rng, G))
        @yield unlock(repair_facility)
        @yield put!(spares, active_process(env))
    end
end

@resumable function start_sim(env::Environment, repair_facility::Resource, spares::Store{Process})
    for i in 1:N
        proc = @process machine(env, repair_facility, spares)
        @yield interrupt(proc)
    end
    for i in 1:S
        proc = @process machine(env, repair_facility, spares)
        @yield put!(spares, proc) 
    end
end

function sim_repair()
    sim = Simulation()
    repair_facility = Resource(sim)
    spares = Store{Process}(sim)
    @process start_sim(sim, repair_facility, spares)
    msg = run(sim)
    stop_time = now(sim)
    println("At time $stop_time: $msg")
    stop_time
end

results = Float64[]
for i in 1:RUNS push!(results, sim_repair()) end
println("Average crash time: ", sum(results)/RUNS)

# output

At time 12715.718224958666: No more spares!
At time 37335.53567595007: No more spares!
At time 30844.62667837361: No more spares!
At time 1601.2524911974856: No more spares!
At time 824.1048708405848: No more spares!
Average crash time: 16664.247588264083
```

# Multi-server Queue
  
## Description

An [M/M/c queue](https://en.wikipedia.org/wiki/M/M/c_queue) is a basic queue with _c_ identical servers, exponentially distributed interarrival times, and exponentially distributed service times for each server. The arrival rate is defined as _λ_ such that the interarrival time distribution has mean _1/λ_. Similarly, the service rate is defined as _μ_ such that the service time distribution has mean _1/μ_ (for each server). The overall traffic intensity of the queue is _ρ = λ / (c * μ)_. If the traffic intensity exceeds one, the queue is unstable and the queue length will grow indefinitely. 

## Code

```jldoctest
using StableRNGs
using Distributions
using ConcurrentSim
using ResumableFunctions

#set simulation parameters
rng = StableRNG(123)
num_customers = 10 # total number of customers generated

# set queue parameters
num_servers = 2 # number of servers
mu = 1.0 / 2 # service rate
lam = 0.9 # arrival rate
arrival_dist = Exponential(1 / lam) # interarrival time distribution
service_dist = Exponential(1 / mu) # service time distribution

# define customer behavior
@resumable function customer(env::Environment, server::Resource, id::Integer, t_a::Float64, d_s::Distribution)
    @yield timeout(env, t_a) # customer arrives
    println("Customer $id arrived: ", now(env))
    @yield request(server) # customer starts service
    println("Customer $id entered service: ", now(env))
    @yield timeout(env, rand(rng,d_s)) # server is busy
    @yield unlock(server) # customer exits service
    println("Customer $id exited service: ", now(env))
end

# setup and run simulation
function setup_and_run()
    sim = Simulation() # initialize simulation environment
    server = Resource(sim, num_servers) # initialize servers
    arrival_time = 0.0
    for i = 1:num_customers # initialize customers
        arrival_time += rand(rng,arrival_dist)
        @process customer(sim, server, i, arrival_time, service_dist)
    end
    run(sim) # run simulation
end
setup_and_run()

# output
Customer 1 arrived: 0.14518451436852475
Customer 1 entered service: 0.14518451436852475
Customer 2 arrived: 0.5941831542903504
Customer 2 entered service: 0.5941831542903504
Customer 3 arrived: 1.5490648267819074
Customer 4 arrived: 1.6242796925312217
Customer 5 arrived: 1.6911000709069648
Customer 1 exited service: 2.200985520126681
Customer 3 entered service: 2.200985520126681
Customer 6 arrived: 2.2989039524296317
Customer 3 exited service: 3.5822120399442174
Customer 4 entered service: 3.5822120399442174
Customer 7 arrived: 4.377930221620456
Customer 8 arrived: 5.16494279700802
Customer 2 exited service: 5.900722829377648
Customer 5 entered service: 5.900722829377648
Customer 9 arrived: 7.0099944106308705
Customer 10 arrived: 7.828990220943469
Customer 5 exited service: 9.634196437885254
Customer 6 entered service: 9.634196437885254
Customer 4 exited service: 9.670688398447817
Customer 7 entered service: 9.670688398447817
Customer 7 exited service: 15.066978111608014
Customer 8 entered service: 15.066978111608014
Customer 8 exited service: 16.655548432659554
Customer 9 entered service: 16.655548432659554
Customer 6 exited service: 17.401833154870328
Customer 10 entered service: 17.401833154870328
Customer 9 exited service: 17.586065352135993
Customer 10 exited service: 18.690264775280085
```
